## ycmd 0%2B20160327%2Bgitc3e6904

=== debian/changelog ===
ycmd (0+20160327+gitc3e6904-1) unstable; urgency=low

  * New upstream release. (Closes: #818070)
  * Refresh patches for new upstream release.
  * Add libclang-3.8-dev and remove libclang-dev from Build-Depends.

 -- Onur Aslan <onur@onur.im>  Sat, 09 Apr 2016 12:22:30 +0300

ycmd (0+20160303+git206efaf-1) unstable; urgency=low

  * New upstream release. (Closes: #818070)
  * Bump Standards-Version to 3.9.7 (no changes).
  * Refresh patches for new upstream version.
  * Add copyright info for third_party/JediHTTP.
  * Exclude javascript and rust tests.
  * Install JediHTTP into usr/lib/ycmd/third_party/.
  * Update 01-python-path.patch to remove AddVendorFolderToSysPath
    function from jedihttp. This package is using system packages for
    jedihttp dependencies.
  * Update d/rules get-orig-source to update only required submodules
    instead of cloning repository recursively.
  * Add python3-nose, python3-hamcrest, python3-webtest, python3-jedi,
    python3-waitress, python3-bottle, python3-requests into Build-Depends 
    for JediHTTP tests.
  * Update d/rules override_dh_auto_test to run JediHTTP tests.
  * Update d/rules override_dh_install to remove JediHTTP tests.
  * Add 05-tern-support.patch to support local node-tern installation.
  * Add python-future, python-pep8 and python-setuptools into
    Build-Depends.
  * Add python-future into Depends.
  * Update 03-gocode-path.patch to remove unused import to get rid of
    flake8 error.
  * Remove golang dependencies and exclude golang tests. ycmd started using
    godef along with gocode, and godef is not available for Debian. golang
    completion is temporary disabled. Users can still use golang
    completion by installing gocode package and putting godef executable
    into /usr/bin/godef or setting godef_binary_path in
    default_settings.json.
  * Set HOME environment variable to $(CURDIR) when running tests.
  * Update d/rules override_dh_auto_clean to remove .noseids and .cache
    directories generated by nosetests.
  * Use HTTPS URI's for Vcs-Git and Vcs-Browser fields.
  * Add README.Debian to provide additional information about supported
    completion engines.
  * Add 06-omnisharp-path.patch to give optional OmniSharp based C#
    additional support.
  * Replace python-flake8 dependency with flake8. (Closes: #818453)
  * Add 07-shebang.patch to add missing script headers to main executable
    file and check_core_version.py.
  * Remove executable permission from some completer modules.

 -- Onur Aslan <onur@onur.im>  Tue, 29 Mar 2016 14:09:34 +0300

ycmd (0+20151019+git0825f85-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches for new upstream version.
  * Remove 04-test-basic-string-alias.patch. Fixed in upstream.
  * Update override_dh_auto_clean to remove *.so* files in d/rules.
  * Update override_dh_auto_test to run ./run_tests.py in d/rules.
  * Install CORE_VERSION instead of EXPECTED_CORE_VERSION.
  * Create a symbolic link to clang includes directory in
    /usr/lib/ycmd. (Closes: #800618)
  * Add libclang-common-(CLANG_VER)-dev into recommends.
  * Replace libclang-3.(6|7) dependencies with libclang-dev (>= 3.6) to
    use default clang version provided by llvm-defaults.
  * Add typescript support:
    - Add node-typescript into Build-Depends and Recommends.
    - Add 04-tsserver-path.patch to use node-typescript for typescript
      completion.
    - Remove excluded typescript tests to activate typescript tests in
      d/rules.
  * Update 00-build-system.patch to add support for libclang-3.8-dev.
  * Update 02-generic-ycm-extra-conf-py.patch to simplify
    ycm_extra_conf.py.

 -- Onur Aslan <onur@onur.im>  Mon, 02 Nov 2015 13:40:20 +0300

ycmd (0+20150804+git6f4dbb4-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches for new upstream version.
  * Replace libclang-dev build dependency with
    libclang-3.6-dev | libclang3.7-dev.
  * Remove clang-3.5 support in 00-build-system.patch.
  * Add 04-test-basic-string-alias.patch.
  * Update d/install to install EXPECTED_CORE_VERSION and
    check_core_version.py
  * Update Upstream-Name and Source URL in debian/copyright.
  * Update copyright info and years.

 -- Onur Aslan <onur@onur.im>  Fri, 07 Aug 2015 12:10:08 +0300

ycmd (0+20150616+gitd7a3653-1) unstable; urgency=low

  * Initial release. (Closes: #771330)

 -- Onur Aslan <onur@onur.im>  Mon, 22 Jun 2015 20:06:43 +0300
