## ycmd 0%2B20191222%2Bgit2771f6f%2Bds

=== examples/requirements.txt ===
enum34>=1.0
requests>=2.5.1
httpie>=0.5.0
