## ycmd 0%2B20240823%2Bgit8b61f19%2Bds

=== debian/changelog ===
ycmd (0+20240823+git8b61f19+ds-2+nmu1~cc1~trixie) testing; urgency=medium

  * Rebuild for new libllvm

 -- Caoimhe Chaos <caoimhechaos@protonmail.com>  Sun, 19 Jan 2025 04:42:34 +0100

ycmd (0+20240823+git8b61f19+ds-2) unstable; urgency=medium

  * Import upstream 0+20241013+gitd8c3b69 as patch series
  * Prefer clangd-19 if we need to pick a versioned clangd
  * Wait for tssserver termination also for 30 seconds

 -- David Kalnischkies <donkult@debian.org>  Tue, 22 Oct 2024 13:00:33 +0200

ycmd (0+20240823+git8b61f19+ds-1) unstable; urgency=medium

  * New upstream version 0+20240823+git8b61f19+ds
    - Refresh patches
  * Bump Standards-Version to 4.7.0 (no change needed)

 -- David Kalnischkies <donkult@debian.org>  Tue, 10 Sep 2024 18:16:51 +0200

ycmd (0+20240618+gite81c15e+ds-1) unstable; urgency=medium

  * New upstream version 0+20240618+gite81c15e+ds
    - Support for type/call hierarchy commands
    - Refresh patches
  * Restore support for older tsserver in tests
  * Skip go tests failing with golang-golang-x-tools 0.20 (gopls)

 -- David Kalnischkies <donkult@debian.org>  Wed, 19 Jun 2024 11:24:19 +0200

ycmd (0+20240401+gitda9c643+ds-1) unstable; urgency=medium

  * New upstream version 0+20240401+gitda9c643+ds
    - Refresh patches and tests
    - Drop now unused python3-{bottle,frozendict} dependencies
  * Prefer versioned clangd-18 over -17 (and older)
  * Include License Header for Apache-2.0 in d/copyright
  * Bump upstream copyright years to 2024 for newly added file
  * Support debian/ files (debputy) completion out of the box
  * Avoid needless internal CORE_VERSION enforcement

 -- David Kalnischkies <donkult@debian.org>  Fri, 05 Apr 2024 22:07:53 +0200

ycmd (0+20231230+git9e43034+ds-2) unstable; urgency=medium

  * Import upstream 0+20240217+gitb63d2e8 as patch series
    - Fixing tests for go v1.22.0 (Closes: #1064498)

 -- David Kalnischkies <donkult@debian.org>  Sat, 24 Feb 2024 12:07:29 +0100

ycmd (0+20231230+git9e43034+ds-1) unstable; urgency=medium

  [ David Kalnischkies ]
  * New upstream version 0+20231230+git9e43034+ds
    - Refresh patches and drop backported ones
  * Bump my copyright year as advised by lintian

  [ Alexandre Detiste ]
  * Remove extraneous obsolete dependency on python3-future (Closes: #1058019)

 -- David Kalnischkies <donkult@debian.org>  Wed, 03 Jan 2024 00:44:54 +0100

ycmd (0+20230611+git3392251+ds-2) unstable; urgency=medium

  * Import upstream 0+20231029+git62cfc45 as patch series
    - Support clang 17 (from experimental) in autopkgtests
  * Prefer upstream-blessed clangd-17 before other versioned clangs
  * Import upstream PR1719 to support Unicode 15.1 (Closes: #1052804)

 -- David Kalnischkies <donkult@debian.org>  Sun, 05 Nov 2023 11:41:38 +0100

ycmd (0+20230611+git3392251+ds-1) unstable; urgency=medium

  * New upstream version 0+20230611+git3392251+ds
    - Refresh patches
    - Make tests compatible with golang-1.20 (Closes: #1037480)
  * Support GDScript (Godot) completion out of the box
  * Prefer upstream-blessed clangd-16 before other versioned clangs
  * Drop as-needed linker flag from debian/rules (lintian)
  * Bump Standards-Version to 4.6.2 (no change needed)

 -- David Kalnischkies <donkult@debian.org>  Wed, 21 Jun 2023 14:05:18 +0200

ycmd (0+20230103+gitf53e7ac+ds-1) unstable; urgency=medium

  * New upstream version 0+20230103+gitf53e7ac+ds
    - implements support for clangd GoToAlternateFile
  * Let service management test wait longer for termination
  * Do not check text of AttributeErrors raised in tests
  * add Repository field in upstream/metadata

 -- David Kalnischkies <donkult@debian.org>  Sat, 14 Jan 2023 16:21:53 +0100

ycmd (0+20220824+git2ee4100+ds-2) unstable; urgency=medium

  * Import upstream 0+20220929+git0e13fec+ds as patch series
    - Keep CORE_VERSION at 45, but provide 47 as well
    - Refresh, rename & reorganize patches
  * Prefer using clangd before clangd-15 over -14, -13 and -16
  * Increase tsserver timeout from 20 to 30 seconds (for armel)
  * Ignore "too slow" failure of clangd FixIt_AlreadyResolved test

 -- David Kalnischkies <donkult@debian.org>  Sun, 16 Oct 2022 11:55:37 +0200

ycmd (0+20220824+git2ee4100+ds-1) unstable; urgency=medium

  * New upstream version 0+20220824+git2ee4100+ds
    - Adds highly experimental inlet hints support
  * Relax clangd fixit matcher for clangd-15
  * Split out tests requiring nodejs into own autopkgtest

 -- David Kalnischkies <donkult@debian.org>  Fri, 26 Aug 2022 19:24:36 +0200

ycmd (0+20220401+gitdbe806f+ds-3) unstable; urgency=medium

  * Import upstream 0+20220609+git20bfbbf as patch series
    - Support for semantic highlighting (experimental)
    - Support for the basic workspace folders in LSP completers
  * Support LSP textDocumentSyncKind
  * Describe state of Fortran completer support better
  * Accept different format fixits from newer gopls in test (Closes: #1016838)
  * Ignore unpaired UTF-8 bidirectional warning from UnicodeTable.inc
  * Rerun go tests on golang as well
  * Drop explicit clangd-14 from test dependencies

 -- David Kalnischkies <donkult@debian.org>  Mon, 08 Aug 2022 19:17:59 +0200

ycmd (0+20220401+gitdbe806f+ds-2) unstable; urgency=medium

  * Import upstream version 0+20220609+git20bfbbf+ds as patch:
    - Allow generic LSP completers to override built in completers
  * Ignore order of Goto locations return by clangd in autopkgtest
  * Update Fortran Language Server definition from lsp-examples

 -- David Kalnischkies <donkult@debian.org>  Fri, 10 Jun 2022 22:45:57 +0200

ycmd (0+20220401+gitdbe806f+ds-1) unstable; urgency=medium

  * New upstream version 0+20220401+gitdbe806f+ds
    - Refresh patches & drop backported upstream patches
    - Remove python3-requests dep
    - Remove python3-waitress dep
    - Add libabsl-dev dep and use it
    - Upstream Core-Version is now 45, drop 42 compat
    - Update copyright for upstream release

