## ycmd 0+20150804+git6f4dbb4

=== debian/control ===
Source: ycmd
Section: devel
Priority: optional
Maintainer: Onur Aslan <onur@onur.im>
Build-Depends: debhelper (>= 9),
 cmake,
 dh-python,
 python-bottle,
 python-dev,
 python-flake8,
 python-hamcrest,
 python-jedi,
 python-nose,
 python-requests,
 python-waitress,
 python-webtest,
 golang [amd64 armel armhf i386],
 gocode [amd64 armel armhf i386],
 google-mock,
 libclang-3.6-dev | libclang-3.7-dev,
 libboost-python-dev,
 libboost-system-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libgtest-dev
X-Python-Version: >= 2.7
Standards-Version: 3.9.6
Homepage: https://github.com/Valloric/ycmd
Vcs-Git: git://anonscm.debian.org/collab-maint/ycmd.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/ycmd.git

Package: ycmd
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends},
 python-bottle,
 python-jedi,
 python-requests (>= 2.2.1),
 python-waitress
Recommends: vim-youcompleteme, gocode
Description: code-completion & comprehension server
 ycmd is a server that provides APIs for code-completion and other
 code-comprehension use-cases like semantic GoTo commands (and others). For
 certain filetypes, ycmd can also provide diagnostic errors and warnings.
